#include "base.as"
#include "races.as"

bool wasRepaired = false;
racesManager races();

void createRaces()
{
	// We add 1 race to the map
	
	double[][]	mountainRoad = {
{ 2792.83, 1666.14, 2596.52, 0, 165.401, 0},
{ 2900.83, 1645.52, 2428.15, 0, 155.136, 0},
{ 3035, 1626.36, 2370.51, 0, 172.1193, 0},
{ 3229.35, 1575.33, 2793.86, 0, 211.997, 0},
{ 3057.42, 1589.75, 3384.9, 0, 148.4651, 0},
{ 3016.64, 1628.24, 3305.51, 0, 164.255, 0},
{ 2926.36, 1666.86, 3209.62, 0, 180.3216, 0},
{ 2860.37, 1714.33, 3615.25, 0, 187.3785, 0},
{ 2782.87, 1731.64, 3492.05, 0, 185.865, 0},
{ 2658.49, 1718.48, 2649.86, 0,183.803, 0}
} ;


		
	//               race name   coordinates   #laps       checkpoint object     startline object          finishline object
	// races.addRace("Ladoga trophy", mountainRoad, races.LAPS_NoLaps, "dgchk", "dgstartgreen");
	races.addRace("Mountain Madness!", mountainRoad, races.LAPS_Unlimited, "RoR-flagGate", "RoR-flagGate");

	// the above code works perfectly, but lets demonstrate another possiblity:
	// int myRaceID = races.addNewEmptyRace();
	// races.setRaceName(myRaceID, "drag race");
	// races.setLaps(myRaceID, races.LAPS_NoLaps);
	// races.addCheckpoint(myRaceID, 0, "new-checkpoint-start", coords4[0]);
	// races.addCheckpoint(myRaceID, 1, "new-checkpoint",       coords4[1]);
	// This is more code, but note how this allows much more flexibility
	// We could for example have added a second checkpoint at position 0.
	// That would have given use 2 start lines for the same race.
	// Another thing that we could do is using another object for each checkpoint.

	
	// register a callback function, that will be called every time a race starts
	races.setCallback("RaceStart", on_raceStart);

	// add a no entry sign at the start of the mud race, to indicate which way you should start
	// game.spawnObject("sign-noentry", "sign-noentry1", vector3(807.118, 5.09987, 1119.97), vector3(0.0, -90.0, 0.0), "", false);
	// game.spawnObject("sign-noentry", "sign-noentry2", vector3(807.118, 5.09987, 1108.97), vector3(0.0, -90.0, 0.0), "", false);

	// add a cancel point for all races (raceID=-1)
	double[][] coords6 = {{ 798.592, 368.514, 629.076, 0, 86.0925, 0}} ;
	races.addCancelPoint(-1, "dgstartgreen", coords6[0], on_cancelPoint);
	
	// add the pitstop event
	// game.spawnObject("trucktrigger", "pitstop", vector3(883.356262, 0.340250, 1302.838745), vector3(0.000010, 0.000000, 0.000000), "PitStopEvent", false);

}

void main()
{
	createRaces();
	
	float a = 0.123;
	game.log("foobar: " + a);
	
	string api_return;
	dictionary dict;
	dict.set("one", 1);
	dict.set("two", "test-string");
	dict.set("time", 1.12354);
	
	int res = game.useOnlineAPI("/submit_race_time/", dict, api_return);
	game.log("useOnlineAPI returned: " + res);
	game.log("useOnlineAPI return string: " + api_return);
}

// called when a truck touches the pitstop object
void PitStopEvent(int trigger_type, string inst, string box, int nodeid)
{
	if(wasRepaired) return;

	// get current truck
	BeamClass @b = game.getCurrentTruck();
	if(b.getWheelSpeed() > 0.1)
	{
		game.flashMessage("stop truck to repair it", 3, -1);
	} else
	{
		game.flashMessage("Repairing...", 3, -1);
		b.reset(true);
		wasRepaired = true;
	}
	
	// TODO: reset wasRepaired at some point ...
	
	// old repair style, requires the truck to be in the event box, otherwise its not found
	//game.repairVehicle(inst, box, true);
}

void eventCallback(int eventnum, int value)
{
	races.eventCallback(eventnum, value);
}

void on_raceStart(dictionary@ info)
{
	game.log("Race started and callback works");
	// you could edit the flashMessage or so, or lock a race, or whatever
}

void on_cancelPoint(dictionary@ info)
{
	game.flashMessage("Race aborted.", 4, -1);
}