#include "base.as"
#include "races.as"

bool wasRepaired = false;
racesManager races();

void createRaces()
{
	// We add 1 race to the map
	
	double[][]	mountainRoad_h = {
{ 897.186, 482.686, 794.761, 0, 338.64, 0     },
{ 952.489, 472.464, 710.404, 0, 338.984, 0    },
{ 1016.36, 461.643, 702.761, 0, 179.931, 0     },
{ 1120.44, 436.649, 909.206, 0, 192.421, 0    },
{ 1019.13, 445.436, 1215.48, 0, 166.4092, 0    },
{ 988.471, 459.912, 1181.48, 0, 321.977, 0    },
{ 963.128, 483.788, 1108.74, 0, 181.0768, 0    },
{ 928.916, 506.2, 1301.71, 0, 188.8689, 0      },
{ 892.11, 515.563, 1251.05, 0, 366.897, 0     },
{ 848.343, 520.274, 1013.71, 0, 389.701, 0    },
{ 830.545, 509.479, 833.96, 0, 362.657, 0     },
{ 902.286, 488.353, 851.387, 0, 374.345, 0    },
};
	
	//               race name   coordinates   #laps       checkpoint object     startline object          finishline object
	// races.addRace("Ladoga trophy", mountainRoad, races.LAPS_NoLaps, "dgchk", "dgstartgreen");
	races.addRace("Mountain Madness - narrow", mountainRoad_h, races.LAPS_Unlimited, "RoR-flagGate", "RoR-flagGate");

	// the above code works perfectly, but lets demonstrate another possiblity:
	// int myRaceID = races.addNewEmptyRace();
	// races.setRaceName(myRaceID, "drag race");
	// races.setLaps(myRaceID, races.LAPS_NoLaps);
	// races.addCheckpoint(myRaceID, 0, "new-checkpoint-start", coords4[0]);
	// races.addCheckpoint(myRaceID, 1, "new-checkpoint",       coords4[1]);
	// This is more code, but note how this allows much more flexibility
	// We could for example have added a second checkpoint at position 0.
	// That would have given use 2 start lines for the same race.
	// Another thing that we could do is using another object for each checkpoint.

	
	// register a callback function, that will be called every time a race starts
	races.setCallback("RaceStart", on_raceStart);

	// add a no entry sign at the start of the mud race, to indicate which way you should start
	// game.spawnObject("sign-noentry", "sign-noentry1", vector3(807.118, 5.09987, 1119.97), vector3(0.0, -90.0, 0.0), "", false);
	// game.spawnObject("sign-noentry", "sign-noentry2", vector3(807.118, 5.09987, 1108.97), vector3(0.0, -90.0, 0.0), "", false);

	// add a cancel point for all races (raceID=-1)
	double[][] coords6 = {{ 798.592, 368.514, 629.076, 0, 86.0925, 0}} ;
	races.addCancelPoint(-1, "dgstartgreen", coords6[0], on_cancelPoint);
	
	// add the pitstop event
	// game.spawnObject("trucktrigger", "pitstop", vector3(883.356262, 0.340250, 1302.838745), vector3(0.000010, 0.000000, 0.000000), "PitStopEvent", false);

}

void main()
{
	createRaces();
	
	float a = 0.123;
	game.log("foobar: " + a);
	
	string api_return;
	dictionary dict;
	dict.set("one", 1);
	dict.set("two", "test-string");
	dict.set("time", 1.12354);
	
	int res = game.useOnlineAPI("/submit_race_time/", dict, api_return);
	game.log("useOnlineAPI returned: " + res);
	game.log("useOnlineAPI return string: " + api_return);
}

// called when a truck touches the pitstop object
void PitStopEvent(int trigger_type, string inst, string box, int nodeid)
{
	if(wasRepaired) return;

	// get current truck
	BeamClass @b = game.getCurrentTruck();
	if(b.getWheelSpeed() > 0.1)
	{
		game.flashMessage("stop truck to repair it", 3, -1);
	} else
	{
		game.flashMessage("Repairing...", 3, -1);
		b.reset(true);
		wasRepaired = true;
	}
	
	// TODO: reset wasRepaired at some point ...
	
	// old repair style, requires the truck to be in the event box, otherwise its not found
	//game.repairVehicle(inst, box, true);
}

void eventCallback(int eventnum, int value)
{
	races.eventCallback(eventnum, value);
}

void on_raceStart(dictionary@ info)
{
	game.log("Race started and callback works");
	// you could edit the flashMessage or so, or lock a race, or whatever
}

void on_cancelPoint(dictionary@ info)
{
	game.flashMessage("Race aborted.", 4, -1);
}